Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions

# ClockObject Class Reference

A ClockObject keeps track of elapsed real time and discrete time. More...

Inheritance diagram for ClockObject:

List of all members.

## Public Types
enum | Mode { MNormal = 0, MNonRealTime = 1, MForced = 2, MDegrade = 3, MSlave = 4, MLimited = 5, MInteger = 6, MIntegerLimited = 7 }
## Public Member Functions
| ClockObject ()
| ClockObject (ClockObject const copy)
double | calcFrameRateDeviation (Thread current_thread)
| Returns the standard deviation of the frame times of the frames rendered over the past get_average_frame_rate_interval() seconds.
double | calcFrameRateDeviation ()
| Returns the standard deviation of the frame times of the frames rendered over the past get_average_frame_rate_interval() seconds.
bool | checkErrors (Thread current_thread)
| Returns true if a clock error was detected since the last time check_errors() was called.
double | getAverageFrameRate (Thread current_thread)
| Returns the average frame rate in number of frames per second over the last get_average_frame_rate_interval() seconds.
double | getAverageFrameRate ()
| Returns the average frame rate in number of frames per second over the last get_average_frame_rate_interval() seconds.
double | getAverageFrameRateInterval ()
| Returns the interval of time (in seconds) over which get_average_frame_rate() averages the number of frames per second to compute the frame rate.
double | getDegradeFactor ()
| In degrade mode, returns the ratio by which the performance is degraded.
double | getDt (Thread current_thread)
| Returns the elapsed time for the previous frame: the number of seconds elapsed between the last two calls to tick().
double | getDt ()
| Returns the elapsed time for the previous frame: the number of seconds elapsed between the last two calls to tick().
int | getFrameCount ()
| Returns the number of times tick() has been called since the ClockObject was created, or since it was last reset.
int | getFrameCount (Thread current_thread)
| Returns the number of times tick() has been called since the ClockObject was created, or since it was last reset.
double | getFrameTime (Thread current_thread)
| Returns the time in seconds as of the last time tick() was called (typically, this will be as of the start of the current frame).
double | getFrameTime ()
| Returns the time in seconds as of the last time tick() was called (typically, this will be as of the start of the current frame).
double | getLongTime ()
| Returns the actual number of seconds elapsed since the ClockObject was created, or since it was last reset.
double | getMaxDt ()
| Returns the current maximum allowable time elapsed between any two frames.
double | getMaxFrameDuration ()
| Returns the maximum frame duration over the last get_average_frame_rate_interval() seconds.
double | getMaxFrameDuration (Thread current_thread)
| Returns the maximum frame duration over the last get_average_frame_rate_interval() seconds.
Mode | getMode ()
| Returns the current mode of the clock.
double | getNetFrameRate ()
| Returns the average frame rate since the last reset.
double | getNetFrameRate (Thread current_thread)
| Returns the average frame rate since the last reset.
double | getRealTime ()
| Returns the actual number of seconds elapsed since the ClockObject was created, or since it was last reset.
| reset ()
| Simultaneously resets both the time and the frame count to zero.
| setAverageFrameRateInterval (double time)
| Specifies the interval of time (in seconds) over which get_average_frame_rate() averages the number of frames per second to compute the frame rate.
| setDegradeFactor (double degrade_factor)
| In degrade mode, sets the ratio by which the performance is degraded.
| setDt (double dt)
| In non-real-time mode, sets the number of seconds that should appear to elapse between frames.
| setFrameCount (int frame_count, Thread current_thread)
| Resets the number of frames counted to the indicated number.
| setFrameCount (int frame_count)
| Resets the number of frames counted to the indicated number.
| setFrameRate (double frame_rate)
| In non-real-time mode, sets the number of frames per second that we should appear to be running.
| setFrameTime (double time)
| Changes the time as reported for the current frame to the indicated time.
| setFrameTime (double time, Thread current_thread)
| Changes the time as reported for the current frame to the indicated time.
| setMaxDt (double max_dt)
| Sets a limit on the value returned by get_dt().
| setMode (Mode mode)
| Changes the mode of the clock.
| setRealTime (double time)
| Resets the clock to the indicated time.
| syncFrameTime (Thread current_thread)
| Resets the frame time to the current real time.
| syncFrameTime ()
| Resets the frame time to the current real time.
| tick ()
| Instructs the clock that a new frame has just begun.
| tick (Thread current_thread)
| Instructs the clock that a new frame has just begun.
## Static Public Member Functions
static TypeHandle | getClassType ()
static ClockObject | getGlobalClock ()
| Returns a pointer to the global ClockObject.

## Detailed Description

A ClockObject keeps track of elapsed real time and discrete time.

In normal mode, get_frame_time() returns the time as of the last time tick() was called. This is the "discrete" time, and is usually used to get the time as of, for instance, the beginning of the current frame.

In other modes, as set by set_mode() or the clock-mode config variable, get_frame_time() may return other values to simulate different timing effects, for instance to perform non-real-time animation. See set_mode().

In all modes, get_real_time() always returns the elapsed real time in seconds since the ClockObject was constructed, or since it was last reset.

You can create your own ClockObject whenever you want to have your own local timer. There is also a default, global ClockObject intended to represent global time for the application; this is normally set up to tick every frame so that its get_frame_time() will return the time for the current frame.

## Member Enumeration Documentation

enum Mode

Enumerator:

  MNormal |
  MNonRealTime |
  MForced |
  MDegrade |
  MSlave |
  MLimited |
  MInteger |
  MIntegerLimited |

## Constructor & Destructor Documentation

ClockObject | ( |  | ) |

ClockObject | ( | ClockObject const | copy | ) |

## Member Function Documentation

double calcFrameRateDeviation | ( | Thread | current_thread | ) |

Returns the standard deviation of the frame times of the frames rendered over the past get_average_frame_rate_interval() seconds.

This number gives an estimate of the chugginess of the frame rate; if it is large, there is a large variation in the frame rate; if is small, all of the frames are consistent in length.

A large value might also represent just a recent change in frame rate, for instance, because the camera has just rotated from looking at a simple scene to looking at a more complex scene.

double calcFrameRateDeviation | ( |  | ) |

Returns the standard deviation of the frame times of the frames rendered over the past get_average_frame_rate_interval() seconds.

This number gives an estimate of the chugginess of the frame rate; if it is large, there is a large variation in the frame rate; if is small, all of the frames are consistent in length.

A large value might also represent just a recent change in frame rate, for instance, because the camera has just rotated from looking at a simple scene to looking at a more complex scene.

bool checkErrors | ( | Thread | current_thread | ) |

Returns true if a clock error was detected since the last time check_errors() was called.

A clock error means that something happened, an OS or BIOS bug, for instance, that makes the current value of the clock somewhat suspect, and an application may wish to resynchronize with any external clocks.

double getAverageFrameRate | ( | Thread | current_thread | ) |

Returns the average frame rate in number of frames per second over the last get_average_frame_rate_interval() seconds.

This measures the virtual frame rate if the clock is in M_non_real_time mode.

double getAverageFrameRate | ( |  | ) |

Returns the average frame rate in number of frames per second over the last get_average_frame_rate_interval() seconds.

This measures the virtual frame rate if the clock is in M_non_real_time mode.

double getAverageFrameRateInterval | ( |  | ) |

Returns the interval of time (in seconds) over which get_average_frame_rate() averages the number of frames per second to compute the frame rate.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from ReferenceCount.

double getDegradeFactor | ( |  | ) |

In degrade mode, returns the ratio by which the performance is degraded.

A value of 2.0 causes the clock to be slowed down by a factor of two (reducing performance to 1/2 what would be otherwise).

This has no effect if mode is not M_degrade.

double getDt | ( | Thread | current_thread | ) |

Returns the elapsed time for the previous frame: the number of seconds elapsed between the last two calls to tick().

double getDt | ( |  | ) |

Returns the elapsed time for the previous frame: the number of seconds elapsed between the last two calls to tick().

int getFrameCount | ( | Thread | current_thread | ) |

Returns the number of times tick() has been called since the ClockObject was created, or since it was last reset.

This is generally the number of frames that have been rendered.

int getFrameCount | ( |  | ) |

Returns the number of times tick() has been called since the ClockObject was created, or since it was last reset.

This is generally the number of frames that have been rendered.

double getFrameTime | ( |  | ) |

Returns the time in seconds as of the last time tick() was called (typically, this will be as of the start of the current frame).

This is generally the kind of time you want to ask for in most rendering and animation contexts, since it's important that all of the animation for a given frame remains in sync with each other.

double getFrameTime | ( | Thread | current_thread | ) |

Returns the time in seconds as of the last time tick() was called (typically, this will be as of the start of the current frame).

This is generally the kind of time you want to ask for in most rendering and animation contexts, since it's important that all of the animation for a given frame remains in sync with each other.

static ClockObject getGlobalClock | ( |  | ) | `[static]`

Returns a pointer to the global ClockObject.

This is the ClockObject that most code should use for handling scene graph rendering and animation.

double getLongTime | ( |  | ) |

Returns the actual number of seconds elapsed since the ClockObject was created, or since it was last reset.

This is similar to get_real_time(), except that it uses the most accurate counter we have over a long period of time, and so it is less likely to drift. However, it may not be very precise for measuring short intervals. On Windows, for instace, this is only accurate to within about 55 milliseconds.

double getMaxDt | ( |  | ) |

Returns the current maximum allowable time elapsed between any two frames.

See set_max_dt().

double getMaxFrameDuration | ( | Thread | current_thread | ) |

Returns the maximum frame duration over the last get_average_frame_rate_interval() seconds.

double getMaxFrameDuration | ( |  | ) |

Returns the maximum frame duration over the last get_average_frame_rate_interval() seconds.

Mode getMode | ( |  | ) |

Returns the current mode of the clock.

See set_mode().

double getNetFrameRate | ( |  | ) |

Returns the average frame rate since the last reset.

This is simply the total number of frames divided by the total elapsed time. This reports the virtual frame rate if the clock is in (or has been in) M_non_real_time mode.

double getNetFrameRate | ( | Thread | current_thread | ) |

Returns the average frame rate since the last reset.

This is simply the total number of frames divided by the total elapsed time. This reports the virtual frame rate if the clock is in (or has been in) M_non_real_time mode.

double getRealTime | ( |  | ) |

Returns the actual number of seconds elapsed since the ClockObject was created, or since it was last reset.

This is useful for doing real timing measurements, e.g. for performance statistics.

This returns the most precise timer we have for short time intervals, but it may tend to drift over the long haul. If more accurate timekeeping is needed over a long period of time, use get_long_time() instead.

reset | ( |  | ) |

Simultaneously resets both the time and the frame count to zero.

setAverageFrameRateInterval | ( | double | time | ) |

Specifies the interval of time (in seconds) over which get_average_frame_rate() averages the number of frames per second to compute the frame rate.

Changing this does not necessarily immediately change the result of get_average_frame_rate(), until this interval of time has elapsed again.

Setting this to zero disables the computation of get_average_frame_rate().

setDegradeFactor | ( | double | degrade_factor | ) |

In degrade mode, sets the ratio by which the performance is degraded.

A value of 2.0 causes the clock to be slowed down by a factor of two (reducing performance to 1/2 what would be otherwise).

This has no effect if mode is not M_degrade.

setDt | ( | double | dt | ) |

In non-real-time mode, sets the number of seconds that should appear to elapse between frames.

In forced mode or limited mode, sets our target dt. In normal mode, this has no effect.

Also see set_frame_rate(), which is a different way to specify the same quantity.

setFrameCount | ( | int | frame_count | ) |

Resets the number of frames counted to the indicated number.

Also see reset(), set_real_time(), and set_frame_time().

setFrameCount | ( | int | frame_count,
|  | Thread | current_thread
| ) |  |

Resets the number of frames counted to the indicated number.

Also see reset(), set_real_time(), and set_frame_time().

setFrameRate | ( | double | frame_rate | ) |

In non-real-time mode, sets the number of frames per second that we should appear to be running.

In forced mode or limited mode, sets our target frame rate. In normal mode, this has no effect.

Also see set_dt(), which is a different way to specify the same quantity.

setFrameTime | ( | double | time,
|  | Thread | current_thread
| ) |  |

Changes the time as reported for the current frame to the indicated time.

Normally, the way to adjust the frame time is via tick(); this function is provided only for occasional special adjustments.

setFrameTime | ( | double | time | ) |

Changes the time as reported for the current frame to the indicated time.

Normally, the way to adjust the frame time is via tick(); this function is provided only for occasional special adjustments.

setMaxDt | ( | double | max_dt | ) |

Sets a limit on the value returned by get_dt().

If this value is less than zero, no limit is imposed; otherwise, this is the maximum value that will ever be returned by get_dt(), regardless of how much time has actually elapsed between frames.

This limit is only imposed in real-time mode; in non-real-time mode, the dt is fixed anyway and max_dt is ignored.

This is generally used to guarantee reasonable behavior even in the presence of a very slow or chuggy frame rame.

setMode | ( | Mode | mode | ) |

Changes the mode of the clock.

Normally, the clock is in mode M_normal. In this mode, each call to tick() will set the value returned by get_frame_time() to the current real time; thus, the clock simply reports time advancing.

Other possible modes:

M_non_real_time - the clock ignores real time completely; at each call to tick(), it pretends that exactly dt seconds have elapsed since the last call to tick(). You may set the value of dt with set_dt() or set_frame_rate().

M_limited - the clock will run as fast as it can, as in M_normal, but will not run faster than the rate specified by set_frame_rate(). If the application would run faster than this rate, the clock will slow down the application.

M_integer - the clock will run as fast as it can, but the rate will be constrained to be an integer multiple or divisor of the rate specified by set_frame_rate(). The clock will slow down the application a bit to guarantee this.

M_integer_limited - a combination of M_limited and M_integer; the clock will not run faster than set_frame_rate(), and if it runs slower, it will run at a integer divisor of that rate.

M_forced - the clock forces the application to run at the rate specified by set_frame_rate(). If the application would run faster than this rate, the clock will slow down the application; if the application would run slower than this rate, the clock slows down time so that the application believes it is running at the given rate.

M_degrade - the clock runs at real time, but the application is slowed down by a set factor of its frame rate, specified by set_degrade_factor().

M_slave - the clock does not advance, but relies on the user to call set_frame_time() and/or set_frame_count() each frame.

setRealTime | ( | double | time | ) |

Resets the clock to the indicated time.

This changes only the real time of the clock as reported by get_real_time(), but does not immediately change the time reported by get_frame_time()--that will change after the next call to tick(). Also see reset(), set_frame_time(), and set_frame_count().

syncFrameTime | ( | Thread | current_thread | ) |

Resets the frame time to the current real time.

This is similar to tick(), except that it does not advance the frame counter and does not affect dt. This is intended to be used in the middle of a particularly long frame to compensate for the time that has already elapsed.

In non-real-time mode, this function has no effect (because in this mode all frames take the same length of time).

syncFrameTime | ( |  | ) |

Resets the frame time to the current real time.

This is similar to tick(), except that it does not advance the frame counter and does not affect dt. This is intended to be used in the middle of a particularly long frame to compensate for the time that has already elapsed.

In non-real-time mode, this function has no effect (because in this mode all frames take the same length of time).

tick | ( |  | ) |

Instructs the clock that a new frame has just begun.

In normal, real-time mode, get_frame_time() will henceforth report the time as of this instant as the current start-of-frame time. In non-real-time mode, get_frame_time() will be incremented by the value of dt.

tick | ( | Thread | current_thread | ) |

Instructs the clock that a new frame has just begun.

In normal, real-time mode, get_frame_time() will henceforth report the time as of this instant as the current start-of-frame time. In non-real-time mode, get_frame_time() will be incremented by the value of dt.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties